function [Dlt_Opt, PHlf_Opt, tauHlf] =fnd_DltMax(H_vDlt, rDlt, epsP, epsT, datDir)

N=length(H_vDlt);

H_rDlt=double(subs(H_vDlt, rDlt));
tauHlf=fnd_tauHlf(H_rDlt, epsP, epsT)

LDlt=0.6*rDlt;
RDlt=1.1*rDlt;

Dlt_ar=[LDlt, RDlt, 0, 0, 0];

p_ed=zeros(1,5);

H_Dlt=double(subs(H_vDlt, Dlt_ar(1)));
psi=expm(-1i*H_Dlt*tauHlf)*eye(N,1);
p_ed(1)=1-psi(1)'*psi(1);

H_Dlt=double(subs(H_vDlt, Dlt_ar(2)));
psi=expm(-1i*H_Dlt*tauHlf)*eye(N,1);
p_ed(2)=1-psi(1)'*psi(1);
n=2;

i=1;
dif=max(p_ed(1:n))-min(p_ed(1:n));

while dif>epsP

    if n == 2
        Dlt_ar(3)=(Dlt_ar(1)+Dlt_ar(2))/2;
        H_Dlt=double(subs(H_vDlt, Dlt_ar(3)));
        psi=expm(-1i*H_Dlt*tauHlf)*eye(N,1);
        p_ed(3)=1-psi(1)'*psi(1);
        n=3;
        continue
    elseif n==3
        if p_ed(1)<p_ed(3) && p_ed(3)<p_ed(2) 
            p_ed(1)=p_ed(3);
            Dlt_ar(1)=Dlt_ar(3);
            n=2;
            i=i+1;
            dif=max(p_ed(1:n))-min(p_ed(1:n));
            continue
        elseif p_ed(1)>p_ed(3) && p_ed(3)>p_ed(2)
            p_ed(2)=p_ed(3);
            Dlt_ar(2)=Dlt_ar(3);
            n=2;
            i=i+1;
            dif=max(p_ed(1:n))-min(p_ed(1:n));
            continue
        else
            Dlt_ar(4)=(Dlt_ar(1)+Dlt_ar(3))/2;
            H_Dlt=double(subs(H_vDlt, Dlt_ar(4)));
            psi=expm(-1i*H_Dlt*tauHlf)*eye(N,1);
            p_ed(4)=1-psi(1)'*psi(1);

            Dlt_ar(5)=(Dlt_ar(2)+Dlt_ar(3))/2;
            H_Dlt=double(subs(H_vDlt, Dlt_ar(5)));
            psi=expm(-1i*H_Dlt*tauHlf)*eye(N,1);
            p_ed(5)=1-psi(1)'*psi(1);
            n=5;
            continue
        end

    elseif n==5
        if p_ed(1)<p_ed(4) && p_ed(4)<p_ed(3) && p_ed(3)<p_ed(5) && p_ed(5)<p_ed(2)
            p_ed(1)=p_ed(5);
            Dlt_ar(1)=Dlt_ar(5);
            n=2;
            i=i+1;
            dif=max(p_ed(1:n))-min(p_ed(1:n));
            continue
        elseif p_ed(1)>p_ed(4) && p_ed(4)>p_ed(3) && p_ed(3)>p_ed(5) && p_ed(5)>p_ed(2)
            p_ed(2)=p_ed(4);
            Dlt_ar(2)=Dlt_ar(4);
            n=2;
            i=i+1;
            dif=max(p_ed(1:n))-min(p_ed(1:n));
            continue
        elseif p_ed(1)<p_ed(4) && p_ed(4)<p_ed(3) && p_ed(3)<p_ed(5)
            p_ed(1)=p_ed(3);
            p_ed(3)=p_ed(5);
            Dlt_ar(1)=Dlt_ar(3);
            Dlt_ar(3)=Dlt_ar(5);
            n=3;
            i=i+1;
            dif=max(p_ed(1:n))-min(p_ed(1:n));
            continue
        elseif p_ed(4)>p_ed(3) && p_ed(3)>p_ed(5) && p_ed(5)>p_ed(2)
            p_ed(2)=p_ed(3);
            p_ed(3)=p_ed(4);
            Dlt_ar(2)=Dlt_ar(3);
            Dlt_ar(3)=Dlt_ar(4);
            n=3;
            i=i+1;
            dif=max(p_ed(1:n))-min(p_ed(1:n));
            continue
        elseif p_ed(1)<p_ed(4) && p_ed(4)<p_ed(3) && p_ed(3)>p_ed(5) && p_ed(5)>p_ed(2)
            p_ed(1)=p_ed(4);
            p_ed(2)=p_ed(5);
            Dlt_ar(1)=Dlt_ar(4);
            Dlt_ar(2)=Dlt_ar(5);
            n=3;
            i=i+1;
            dif=max(p_ed(1:n))-min(p_ed(1:n));
            continue
        else
            i=i+1
            dif=max(p_ed(1:n))-min(p_ed(1:n))
            error('not convex function.')
        end
    end
end

Dlt_Opt=Dlt_ar(n);
PHlf_Opt=p_ed(n);



if PHlf_Opt<0.4
    fprintf('pEnd=%f', PHlf_Opt)
    error('pEnd too small')
end


end