function [Omega1, rDlt, wDlt, E_r, E_w_cp, E_w_Ncp]=fnd_O1(g_t, g_o, Omega2, kappa_t, kappa_o, dir)

% g_t=sPara(1);
% g_o=sPara(2);
% Omega2=sPara(3);
% kappa_t=sPara(4);
% kappa_o=sPara(5);


load([dir,'Mtx.mat'], 'H_r_eff', 'H_w_eff')
syms G_t G_o O2 K_t K_o
E_r=eig(double(subs(H_r_eff, [G_t, G_o, O2, K_t, K_o], [g_t, g_o, Omega2, kappa_t, kappa_o])));
E_r=sort(real(E_r), 'descend');
rDlt=E_r(1);

[Psi_w, E_w]=eig(double(subs(H_w_eff, [G_t, G_o, O2, K_t, K_o], [g_t, g_o, Omega2, kappa_t, kappa_o])));
load([dir,'CGC.mat'], 'G2H');
stren=double(G2H)'*Psi_w(1:3,:);
ind=find(abs(stren)>1e-2);

E_w=diag(E_w);
E_w_cp=E_w(ind);
E_w_cp=sort(real(E_w_cp), 'descend');
wDlt=E_w_cp(1);
Omega1=(rDlt-wDlt)/8;



E_w(ind, :)=[];
E_w_Ncp=sort(real(E_w), 'descend');

end