function tau=fnd_tauHlf(H, epsP, epsT)

N=length(H);

tar=0.98/2;  %your best guess

us=1;
tauL0=0;
tauR0=100*us;

tauL=tauL0;
tauR=tauR0;
tau=(tauL+tauR)/2;

i=0;
while 1
    
    psi=expm(-1i*H*tau)*eye(N,1);
    dif=1-psi(1)'*psi(1)-tar;

    if tau-tauL0<epsT || tauR0-tau<epsT
        fprintf('tau=%f',tau)
        error('range too small.')
    elseif abs(dif) < epsP
        break;
    elseif dif<0
        tauL=tau;
        tau=0.5*(tauL+tauR);
    else
        tauR=tau;
        tau=0.5*(tauL+tauR);
    end
    i=i+1;
end






end