function [h1, h2]=fnd_h1h2(sPara, epsP, dir)


% find optimal h1
h2=8;   % set it larger ensuring that all the population comes out.
% h1L0=0.7079;  %for T2
% h1R0=0.7085;   %should not excced 1.

h1L0=0.9;   %for T1
h1R0=1.5;   %should not excced 1.


h1L=h1L0;
h1R=h1R0;
h1=(h1L+h1R)/2;

i=0;
while 1
    i;
    h1;
    [~,~,~, p_hf, p_ed, ~,~] = evolAll(sPara, h1, h2, dir);
    p_ed;
    dif=p_hf-0.5*p_ed;

    if h1-h1L0<100*epsP || h1R0-h1<100*epsP
        fprintf('h1=%f',h1)
        error('h1 range too small.')
    elseif abs(dif) < epsP
        h1;
        break;
    elseif dif>0
        h1R=h1;
        h1=0.5*(h1L+h1R);
    else
        h1L=h1;
        h1=0.5*(h1L+h1R);
    end
    i=i+1;
end

% find h2
% h2L0=4.3747;   %for T2
% h2R0=4.3753;

h2L0=2;  %for T1
h2R0=6;

h2L=h2L0;
h2R=h2R0;
h2=(h2L+h2R)/2;

i=0;
while 1
    i;
    h2;
    [~,~,~, ~, ~, pkE,pkL] = evolAll(sPara, h1, h2, dir);
    pkL;
    dif=pkE-pkL;

    if h2-h2L0<100*epsP || h2R0-h2<100*epsP
        fprintf('h1=%f, h2=%f',h1, h2)
        error('h2 range too small.')
    elseif abs(dif) < epsP
        h2;
        break;
    elseif dif>0
        h2L=h2;
        h2=0.5*(h2L+h2R);
    else
        h2R=h2;
        h2=0.5*(h2L+h2R);
    end
    i=i+1;
end

end